;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:createpro
;
; PURPOSE:ecrit un .pro le compile et l''execute
;
; CATEGORY:
;
; CALLING SEQUENCE:createpro, command
; 
; INPUTS:
;       command:un vecteur de string contenant les intructions a
;       passer pour construire la procedure
;
; KEYWORD PARAMETERS:
;       filenamein: un string donnant le nom de la procedure a ecrire
;
; OUTPUTS:
;
; COMMON BLOCKS:
;
; SIDE EFFECTS:complete filename par '.pro' si besion
;
; RESTRICTIONS:de marche pas pour les fonctions
;
; EXAMPLE:
;      IDL> createpro, ['print,''OK'''],filename='test'
;
; MODIFICATION HISTORY:Sebastien Masson (smasson@lodyc.jussieu.fr)
;
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
PRO createpro, command, filenamein = filenamein

   if NOT keyword_set(filenamein) then filename = 'for_createpro.pro' $
   ELSE BEGIN
      filename = filenamein
      if rstrpos(filename, '.pro') NE strlen(filename)-4 then $
       filename = filename+'.pro'
   ENDELSE
   shortfilename = strmid(filename,  0, strlen(filename)-4)
   thisOS = strupcase(strmid(!version.os_family, 0, 3))
   CASE thisOS of
      'MAC':sep = ':'
      'WIN':sep = '\'
      ELSE:sep = '/'
   ENDCASE
   shortfilename = strmid(shortfilename, rstrpos(shortfilename, sep)+1)
   if rstrpos(shortfilename, sep) GE 1 then begin
      directory = strmid(filename,  0,  rstrpos(shortfilename, sep))
      directory = isadirectory(io = directory, $
                               title = 'Bad definition of Directory: '+directory)
   endif
   putfile, filename, ['pro '+shortfilename, command, 'return', 'end']
   resolve_routine, shortfilename
   rien = execute(shortfilename)
   return
end
